#!/usr/bin/env python
#grow-shrink-live.py
# Creator: TT
# MrQ: replace Entry to Slider & Spinner
# Open Source

from gimpfu import *
import gtk, gimpui
gimpui.gimp_ui_init ()

# Global variables to store the parameters used for our effect/work to show preview or actual layer when user OK it
global_param1 = 0 #in this example it's shrinkgrow radius
global_param2 = 0   #in this example it's feather_radius
global_param3 = 0  #in this example it's iterations
global_param4 = 18   #in this example it's enhance_shadows


sample_integer = 18
pattern_ = "3,-2"       
image = 0 #we'll set these when dialog() is called so that we can access them later
drawable = 0
has_preview = False
preview_layer = 0
selection_channel = 0
proceed_with_changes = False

def apply_effect(layer): #function to do work on either preview layer or actual drawable when user clicks OK

    global preview_layer,has_preview
    if has_preview == True:
        pdb.gimp_image_remove_vectors(image,preview_layer)
        has_preview = False
        sample_integer=global_param4		
        points = int(sample_integer) #make sure it's int
        pattern = [int(x) for x in pattern_.split(',')] #make it array of ints
        vectors = pdb.gimp_image_get_active_vectors(image)
        num_strokes,stroke_ids = pdb.gimp_vectors_get_strokes(vectors)
        length = pdb.gimp_vectors_stroke_get_length(vectors,stroke_ids[0],0.1)
        sectionlength = length*1.0/points
        p = []
        #get all the points coordinates into p array
        for i in range(0,points):
            dist = sectionlength*i
            x,y,slope,valid = pdb.gimp_vectors_stroke_get_point_at_dist(vectors,stroke_ids[0],dist,0.1)
            p.append([x,y])
       
        cp = [] #control points
        checkpattern = [];
        currentpoint = 0;
        cp.append(currentpoint)
        firsttime=1;
        while 1==1: #loop until we break from it
            for i in range(0,len(pattern)):
                currentpoint = ((currentpoint + points) + pattern[i] ) % points;
                cp.append(currentpoint)
            if (firsttime==1):
                checkpattern = cp[:] #copy this initial pattern to know when to stop
                firsttime = 0
            else:
                good = 1
                l = len(checkpattern)
                for j in range(0,l):
                    if (cp[len(cp)-l+j]!=checkpattern[j]):
                        good = 0
                        break;
                if good==1: #it's all the same as checkpattern so we've done looping
                    cp = cp[0:-(l-1)]
                    break
        #here we have cp containing all our points index now create the path
        new_vectors = pdb.gimp_vectors_new(image,"String Art")
        pdb.gimp_image_insert_vectors(image,new_vectors,None,0)
        cpoints = []
        for i in range(0,len(cp)):
            cpoints = cpoints + (p[cp[i]]*3) #add 3 times the current point
        npoints = len(cpoints)
        stroke_id = pdb.gimp_vectors_stroke_new_from_points(new_vectors,0,npoints,cpoints,FALSE)
        pdb.gimp_item_set_visible(new_vectors,TRUE)
        preview_layer = new_vectors
        has_preview = True

def apply_final(layer): #wrapper to apply effect on final and remove preview_layer meant to be called by on_ok_button_clicked
    pass

# Function to update the live preview
def update_live_preview(): #this is called everytime some parameter changes

    global global_param0, global_param1, global_param2, global_param3, global_param4, global_param5, global_param6
    global image,drawable
    global has_preview,preview_layer #deal with preview layer

    if not has_preview: #create a preview layer
    
        sample_integer=global_param4
        points = int(sample_integer) #make sure it's int
        pattern = [int(x) for x in pattern_.split(',')] #make it array of ints
        vectors = pdb.gimp_image_get_active_vectors(image)
        num_strokes,stroke_ids = pdb.gimp_vectors_get_strokes(vectors)
        length = pdb.gimp_vectors_stroke_get_length(vectors,stroke_ids[0],0.1)
        sectionlength = length*1.0/points
        p = []
        #get all the points coordinates into p array
        for i in range(0,points):
            dist = sectionlength*i
            x,y,slope,valid = pdb.gimp_vectors_stroke_get_point_at_dist(vectors,stroke_ids[0],dist,0.1)
            p.append([x,y])
       
        cp = [] #control points
        checkpattern = [];
        currentpoint = 0;
        cp.append(currentpoint)
        firsttime=1;
        while 1==1: #loop until we break from it
            for i in range(0,len(pattern)):
                currentpoint = ((currentpoint + points) + pattern[i] ) % points;
                cp.append(currentpoint)
            if (firsttime==1):
                checkpattern = cp[:] #copy this initial pattern to know when to stop
                firsttime = 0
            else:
                good = 1
                l = len(checkpattern)
                for j in range(0,l):
                    if (cp[len(cp)-l+j]!=checkpattern[j]):
                        good = 0
                        break;
                if good==1: #it's all the same as checkpattern so we've done looping
                    cp = cp[0:-(l-1)]
                    break
        #here we have cp containing all our points index now create the path
        new_vectors = pdb.gimp_vectors_new(image,"String Art")
        pdb.gimp_image_insert_vectors(image,new_vectors,None,0)
        cpoints = []
        for i in range(0,len(cp)):
            cpoints = cpoints + (p[cp[i]]*3) #add 3 times the current point
        npoints = len(cpoints)
        stroke_id = pdb.gimp_vectors_stroke_new_from_points(new_vectors,0,npoints,cpoints,FALSE)
        pdb.gimp_item_set_visible(new_vectors,TRUE)
        preview_layer = new_vectors
        has_preview = True #now set it true so we can deal with existing layer in later calls
    else: # already have preview layer
        pass

    apply_effect(preview_layer)
   
def dialog(image_, drawable_):
    global image, drawable, save_foreground

    image = image_

    dialog = gtk.Dialog("String-Art Live Preview", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT)
    dialog.set_default_size(530, 100)
	
    #-------------------------------------------------------------  
    hbox0 = gtk.HBox()
    dialog.vbox.pack_start(hbox0, expand=True, fill=True)
    pattern_label = gtk.Label("This plugin works on your existing TOP path.\n")	
    hbox0.pack_start(pattern_label, expand=True, fill=True, padding=5)
    #-------------------------------------------------------------

    hbox4 = gtk.HBox()
    dialog.vbox.pack_start(hbox4, expand=True, fill=True)
    label4 = gtk.Label("\nPoints on Paths:")
    hbox4.pack_start(label4, expand=False, fill=False, padding=5)
    adjustment4 = gtk.Adjustment(value=18, lower=2, upper=1000, step_incr=1, page_incr=0)
    param4_scale = gtk.HScale(adjustment=adjustment4)
    param4_scale.set_digits(0)  # Display only integers
    hbox4.pack_start(param4_scale, expand=True, fill=True, padding=5)
    label4 = gtk.SpinButton(adjustment4,0, 0 )
    hbox4.pack_start(label4, expand=False, fill=False, padding=5)	
    param4_scale.connect("value-changed", on_param4_changed)
   
    #-------------------------------------------------------------

    hbox0 = gtk.HBox()
    dialog.vbox.pack_start(hbox0, expand=True, fill=True)
    pattern_label = gtk.Label("\n                    (ie 3,-2 means forward 3 points and backward 2 points)")	
    hbox0.pack_start(pattern_label, expand=True, fill=True, padding=5)
	
    #-------------------------------------------------------------
	
    hbox5 = gtk.HBox()
    dialog.vbox.pack_start(hbox5, expand=True, fill=True)
    label5 = gtk.Label("String Pattern:  ")
    hbox5.pack_start(label5, expand=False, fill=False, padding=5)
    entry5 = gtk.Entry()
    entry5.set_text("3,-2")
    entry5.set_width_chars(50)  # Adjust the width of input box as needed
    entry5.connect("changed", on_pattern_changed)
    hbox5.pack_start(entry5, expand=False, fill=False, padding=5)

    #-------------------------------------------------------------
	
    cancel_buton = dialog.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
    cancel_buton.connect("clicked", cancel)
	
    #-------------------------------------------------------------

    ok_button = dialog.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
    ok_button.connect("clicked", on_ok_button_clicked)
	
    #-------------------------------------------------------------
	
    dialog.show_all()
    update_live_preview() #call this once so we see effect
    dialog.run()

def on_param4_changed(scale):
    global global_param4
    global_param4 = scale.get_value()
    update_live_preview()
	
def on_pattern_changed(entry):
    global pattern_
    try:
        pattern_ = str(entry.get_text()) #int(entry.get_text())
        #pdb.gimp_message(pattern_)
        update_live_preview()
    except ValueError:
        # Handle the case where the input is not a valid integer
        pass
		
def cancel(cancel_buton, data=None):
    global preview_layer
    pdb.gimp_image_remove_vectors(image,preview_layer)

def on_ok_button_clicked(button, data=None):
    global drawable
    apply_final(preview_layer)          #preview layer because we don't want to apply the invert to final layer it's just for viewing
    button.get_toplevel().destroy()     #destroys the gtk dialog window
	
# Register the Python-Fu plugin
register(
    "python_fu_string_art_live",
    "Create string art",
    "Create string art",
    "TT",
    "TT",
    "2023.12.09",
    "<Image>/Filters/Path/String Art LP...",  # Menu location
    "*",  # Image type
    [],
    [],
    dialog
)

main()